



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>cpp 4个类型转换</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">cpp 4个类型转换</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-17 10:33:49 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>static_cast、dynamic_cast、reinterpret_cast、const_cast 之间的区别</h3>
<h4>static_cast</h4>
<p>用法:static_cast  (expression)<br />
说明:该运算符把expression转换为typeid类型，但没有运行时类型检查来确保转换的安全性。<br />
用途:</p>
<ul><li>用于类层次结构中基类和派生类之间指针或者引用的转换。up-casting (把派生类的指针或引用转换成基类的指针或者引用表示)是安全的；down-casting(把基类指针或引用转换成子类的指针或者引用)是不安全的。</li>
<li>用于基本数据类型之间的转换，如把int转换成char，这种转换的安全性也要由开发人员来保证。</li>
<li>可以把空指针转换成目标类型的空指针(null pointer)。</li>
<li>把任何类型的表达式转换成void类型。</li>
<li>注意： static_cast不能转换掉expression的const、volitale或者__unaligned属性。</li></ul>
<h4>dynamic_cast</h4>
<p>用法:dynamic_cast  (expression)<br />
说明:该运算符把expression转换成typeid类型的对象。typeid必须是类的指针、类的引用或者void*。如果typeid是类的指针类型，那么expression也必须是指针，如果typeid是一个引用，那么expression也必须是一个引用。一般情况下，dynamic_cast用于具有多态性的类(即有虚函数的类)的类型转换。</p>
<p>dynamic_cast依赖于RTTI信息，其次，在转换时，dynamic_cast会检查转换的source对象是否真的可以转换成target类型，这种检查不是语法上的，而是真实情况的检查。先看RTTI相关部分，通常，许多编译器都是通过vtable找到对象的RTTI信息的，这也就意味着，如果基类没有虚方法，也就无法判断一个基类指针变量所指对象的真实类型，这时候，dynamic_cast只能用来做安全的转换,例如从派生类指针转换成基类指针。而这种转换其实并不需要dynamic_cast参与。也就是说,dynamic_cast是根据RTTI记载的信息来判断类型转换是否合法的。</p>
<p>用途:</p>
<ul><li><p>主要用于类层次之间的up-casting和down-casting，还可以用于类之间的交叉转换。在进行down-casting时，dynamic_cast具有类型检查的功能，比static_cast更安全。检测在运行时进行。如果被转换的指针不是一个被请求的有效完整的对象指针，返回值为NULL。当用于多态类型时，它允许任意的隐式类型转换以及相反过程。不过，与static_cast不同，在后一种情况里（注：即隐式转 换的相反过程），dynamic_cast会检查操作是否有效。也就是说，它会检查转换是否会返回一个被请求的有效的完整对象。</p></li>
<li><p>注意：dynamic_cast不能转换掉expression的const、volitale或者__unaligned属性。</p></li></ul>
<h4>reinterpret_cast</h4>
<p>用法:reinterpret_cast (expression)<br />
说明：转换一个指针为其他类型的指针，也允许将一个指针转换为整数类型，反之亦然。这个操作符能够在非相关的类型之间进行转换。操作结果只是简单的从一个指针到别的指针的值的二进制拷贝，在类型之间指向的内容不做任何类型的检查和转换。这是一个强制转换。使用时有很大的风险，慎用之。<br />
注意：reinterpret _cast不能转换掉expression的const、volitale或者__unaligned属性。</p>
<h4>const_cast</h4>
<p>用法：const_cast(expression)<br />
说明：这个类型操纵传递对象的const属性，或者是设置或者是移除。如：<br />
Class C{…}<br />
const C* a = new C;<br />
C* b = const_cast(a);<br />
如果将上面的const_cast转换成其他任何其他的转换，编译都不能通过，出错的信心大致如下：<br />
“…cannot convert from 'const class C <em>' to 'class C </em>'”。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kpm779.html">appium 自动化测试之知乎Android客户端</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqll76kq.html">通过SSH连接linux服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pgwgk9.html">R语言向量</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdkn709.html">des加密解密&mdash;&mdash;java加密，php解密</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnkx1pq.html">jquery easyui的扩展验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k12g069.html">无线路由器的&OpenCurlyDoubleQuote;克隆MAC地址&rdquo;是干什么作用的？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnr222q.html">http&colon;&sol;&sol;blog&period;csdn&period;net&sol;xyang81&sol;article&sol;details&sol;7292380</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd4prl8.html">Fidder的几点补充</a>
		</li>
						<li><a href="https://www.batexi.com/a/9geexo08.html">图片切割工具---产生多个div切割图片 采用for和一的二维阵列设置背景位置</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m6zn38.html">linux系统中的时间</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv215rz9.html">NodeJS-静态服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2531moq.html">Kubernetes应用健康检查</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e47r1x9.html">&lbrack;USACO&rsqb;地震 （二分答案&plus;最优比率生成树详解）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve147o9.html">一个小栗子聊聊JAVA泛型基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn4lw7q.html">《modern-php》 - 阅读笔记 - 最佳实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvekxwx9.html">Java 集合框架：HashMap</a>
		</li>
						<li><a href="https://www.batexi.com/a/q77o52kq.html">Porting QML Applications to Qt 5</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pmwrkd9.html">浅谈App原生开发、混合开发及HTML5开发的优劣</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlo1gvkq.html">给大家推荐：五个Python小项目，Github上的人气很高的</a>
		</li>
						<li><a href="https://www.batexi.com/a/96mkoly8.html">Kafka具体解释五、Kafka Consumer的底层API- SimpleConsumer</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/m8zk5e18.html">【bzoj1913】 Apio2010&mdash;signaling 信号覆盖</a>
			</li>
						<li><a href="https://www.batexi.com/a/m9636xn9.html">SpringBoot源码解析：AOP思想以及相应的应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96361n9.html">关于LuCi</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqloej1q.html">windows下 nvm下载node被墙了解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq15mo49.html">ID还是普通字段做外键合适？</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqloe36q.html">【Beta】第四次任务发布</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlome1q.html">SmohanTimeLine&period;js  酷炫的时间轴效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q77mxjq.html">JS实现网页批量下载文件，支持PC&sol;手机</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9je0008.html">&amp;lt&semi;&amp;lt&semi;&amp;lt&semi; html5本地储存</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8od4oxq.html">&lbrack;nginx学习之道&rsqb;linux的nginx安装</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
